config/routes.rb
Saas::Application.routes.draw do
  root to: 'plans#index'
  resources :subscriptions
  resources :plans
  get 'paypal/checkout', to: 'subscriptions#paypal_checkout'
end

app/models/paypal_payment.rb
class PaypalPayment
  def initialize(subscription)
    @subscription = subscription
  end
  
  def checkout_details
    process :checkout_details
  end
  
  def checkout_url(options)
    process(:checkout, options).checkout_url
  end
  
  def make_recurring
    process :request_payment
    process :create_recurring_profile, period: :monthly, frequency: 1, start_at: Time.zone.now
  end
  
private

  def process(action, options = {})
    options = options.reverse_merge(
      token: @subscription.paypal_payment_token,
      payer_id: @subscription.paypal_customer_token,
      description: @subscription.plan.name,
      amount: @subscription.plan.price,
      currency: "USD"
    )
    response = PayPal::Recurring.new(options).send(action)
    raise response.errors.inspect if response.errors.present?
    response
  end
end

app/models/plan.rb
class Plan < ActiveRecord::Base
  has_many :subscriptions
end

app/models/subscription.rb
class Subscription < ActiveRecord::Base
  belongs_to :plan
  validates_presence_of :plan_id
  validates_presence_of :email
  
  attr_accessor :stripe_card_token, :paypal_payment_token
  
  def save_with_payment
   # abort "save_with_payment"
    if valid?
      if paypal_payment_token.present?
        save_with_paypal_payment
      else
        save_with_stripe_payment
      end
    end
  end
  
  def paypal
   # abort "paypal"
    PaypalPayment.new(self)
  end
  
  def save_with_paypal_payment

   # abort "save_with_paypal_payment"

    response = paypal.make_recurring
    self.paypal_recurring_profile_token = response.profile_id
    save!
  end

  def save_with_stripe_payment

   # abort "save_with_stripe_payment"

    customer = Stripe::Customer.create(description: email, plan: plan_id, card: stripe_card_token)
    self.stripe_customer_token = customer.id
    save!
  rescue Stripe::InvalidRequestError => e
    logger.error "Stripe error while creating customer: #{e.message}"
    errors.add :base, "There was a problem with your credit card."
    false
  end
  
  def payment_provided?
    stripe_card_token.present? || paypal_payment_token.present?
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery
end

app/controllers/plans_controller.rb
class PlansController < ApplicationController
  def index
    @plans = Plan.order("price")
  end
end

app/controllers/subscriptions_controller.rb
class SubscriptionsController < ApplicationController
  def new
    plan = Plan.find(params[:plan_id])

    @subscription = plan.subscriptions.build
    if params[:PayerID]
      @subscription.paypal_customer_token = params[:PayerID]
      @subscription.paypal_payment_token = params[:token]
      @subscription.email = @subscription.paypal.checkout_details.email
    end
  end

  def create
    @subscription = Subscription.new(params[:subscription])
    abort @subscription.to_yaml
    if @subscription.save_with_payment
      redirect_to @subscription, :notice => "Thank you for subscribing!"
    else
      render :new
    end
  end

  def show
    @subscription = Subscription.find(params[:id])
  end
  
  def paypal_checkout
    plan = Plan.find(params[:plan_id])
    subscription = plan.subscriptions.build
    redirect_to subscription.paypal.checkout_url(
      return_url: new_subscription_url(:plan_id => plan.id),
      cancel_url: root_url
    )
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/plans_helper.rb
module PlansHelper
end

app/helpers/subscriptions_helper.rb
module SubscriptionsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Llama Kisses</title>
  <%= stylesheet_link_tag    "application" %>
  <%= javascript_include_tag "https://js.stripe.com/v1/", "application" %>
  <%= csrf_meta_tags %>
  <%= tag :meta, :name => "stripe-key", :content => STRIPE_PUBLIC_KEY %>
</head>
<body>
  <div id="container">
    <% flash.each do |name, msg| %>
      <%= content_tag :div, msg, :id => "flash_#{name}" %>
    <% end %>
    <%= yield %>
  </div>
</body>
</html>

app/views/plans/index.html.erb
<div id="plans">
  <h1>Llama Kisses</h1>
  <% @plans.each do |plan| %>
    <div class="plan">
      <div class="name"><%= plan.name %></div>
      <div class="details">
        <div class="price">
          <%= number_to_currency plan.price, :precision => 0 %>
        </div>
        <div class="per_month">per month</div>
        <div class="kisses"><%= plan.kisses %> kisses</div>
        <div class="per_month">per month</div>
        <div class="signup">
          <%= link_to "Sign up", new_subscription_path(:plan_id => plan.id) %>
        </div>
      </div>
    </div>
  <% end %>
  <div class="clear"></div>
</div>
<style>


// Place all the styles related to the home controller here.
// They will automatically be included in application.css.
// You can use Sass (SCSS) here: http://sass-lang.com/
#plans {
  background-image: image-url("assets/images/llama.jpg");
  background-repeat: no-repeat;
  background-position: 480px -10px;
  margin: 0 auto;
  padding-top: 60px;
  margin-bottom: 10px;
  width: 642px;
  h1 {
    font-size: 65px;
    font-family: Georgia, Times;
    margin-top: 0;
    margin-bottom: 12px;
  }
  .plan {
    float: left;
    width: 150px;
    text-align: center;
    margin-right: 10px;
    .name {
      color: #FFF;
      padding: 5px 0;
      border: solid 1px #5B6881;
      border-bottom: none;
      background: #386FB2;
      background: -webkit-gradient(linear, left top, left bottom, from(#67B0EF), to(#2B5EA4));
      background: -moz-linear-gradient(top,  #579CEA,  #2B5EA4);
      filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#579CEA', endColorstr='#2B5EA4');
      border-top-left-radius: 5px;
      border-top-right-radius: 5px;
      -webkit-border-top-left-radius: 5px;
      -webkit-border-top-right-radius: 5px;
      -moz-border-radius-topleft: 5px;
      -moz-border-radius-topright: 5px;
    }
    .details {
      padding-top: 5px;
      border: solid 1px #8D8D8D;
      background-color: #E8F4FD;
      border-top: none;
      border-bottom-left-radius: 5px;
      border-bottom-right-radius: 5px;
      -webkit-border-bottom-left-radius: 5px;
      -webkit-border-bottom-right-radius: 5px;
      -moz-border-radius-bottomleft: 5px;
      -moz-border-radius-bottomright: 5px;
    }
    .price {
      font-size: 50px;
    }
    .per_month {
      font-size: 12px;
      margin-bottom: 10px;
      color: #5E5E5E;
    }
    .kisses {
      font-size: 18px;
    }
    .signup {
      margin: 20px;
      a {
        font-size: 13px;
        padding: 5px 10px 6px 10px;
        font-weight: bold;
        border: 1px solid #2A7531;
        border-radius: 4px;
        -webkit-border-radius: 4px;
        -moz-border-radius: 4px;
        color: #FFF;
        background: #328039;
        background: -webkit-gradient(linear, left top, left bottom, from(#56D854), to(#328039));
        background: -moz-linear-gradient(top,  #56D854,  #328039);
        filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#56D854', endColorstr='#328039');
        text-decoration: none;
        text-shadow: 0 -1px 0 #036;
      }
    }
  }
}
</style>

app/views/subscriptions/show.html.erb
<div id="subscription">
  <h1>Your Subscription</h1>
  <p>You have signed up for the <strong><%= @subscription.plan.name %></strong> plan which includes <strong><%= @subscription.plan.kisses %> llama kisses</strong> for just <strong><%= number_to_currency @subscription.plan.price %></strong> per month!</p>
</div>